var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  CompactEncrypt: () => import_encrypt2.CompactEncrypt,
  CompactSign: () => import_sign.CompactSign,
  EmbeddedJWK: () => import_embedded.EmbeddedJWK,
  EncryptJWT: () => import_encrypt4.EncryptJWT,
  FlattenedEncrypt: () => import_encrypt3.FlattenedEncrypt,
  FlattenedSign: () => import_sign2.FlattenedSign,
  GeneralEncrypt: () => import_encrypt.GeneralEncrypt,
  GeneralSign: () => import_sign3.GeneralSign,
  SignJWT: () => import_sign4.SignJWT,
  UnsecuredJWT: () => import_unsecured.UnsecuredJWT,
  base64url: () => base64url,
  calculateJwkThumbprint: () => import_thumbprint.calculateJwkThumbprint,
  calculateJwkThumbprintUri: () => import_thumbprint.calculateJwkThumbprintUri,
  compactDecrypt: () => import_decrypt.compactDecrypt,
  compactVerify: () => import_verify.compactVerify,
  createLocalJWKSet: () => import_local.createLocalJWKSet,
  createRemoteJWKSet: () => import_remote.createRemoteJWKSet,
  decodeJwt: () => import_decode_jwt.decodeJwt,
  decodeProtectedHeader: () => import_decode_protected_header.decodeProtectedHeader,
  errors: () => errors,
  exportJWK: () => import_export.exportJWK,
  exportPKCS8: () => import_export.exportPKCS8,
  exportSPKI: () => import_export.exportSPKI,
  flattenedDecrypt: () => import_decrypt2.flattenedDecrypt,
  flattenedVerify: () => import_verify2.flattenedVerify,
  generalDecrypt: () => import_decrypt3.generalDecrypt,
  generalVerify: () => import_verify3.generalVerify,
  generateKeyPair: () => import_generate_key_pair.generateKeyPair,
  generateSecret: () => import_generate_secret.generateSecret,
  importJWK: () => import_import.importJWK,
  importPKCS8: () => import_import.importPKCS8,
  importSPKI: () => import_import.importSPKI,
  importX509: () => import_import.importX509,
  jwtDecrypt: () => import_decrypt4.jwtDecrypt,
  jwtVerify: () => import_verify4.jwtVerify
});
module.exports = __toCommonJS(src_exports);
var import_decrypt = require("./jwe/compact/decrypt.js");
var import_decrypt2 = require("./jwe/flattened/decrypt.js");
var import_decrypt3 = require("./jwe/general/decrypt.js");
var import_encrypt = require("./jwe/general/encrypt.js");
var import_verify = require("./jws/compact/verify.js");
var import_verify2 = require("./jws/flattened/verify.js");
var import_verify3 = require("./jws/general/verify.js");
var import_verify4 = require("./jwt/verify.js");
var import_decrypt4 = require("./jwt/decrypt.js");
var import_encrypt2 = require("./jwe/compact/encrypt.js");
var import_encrypt3 = require("./jwe/flattened/encrypt.js");
var import_sign = require("./jws/compact/sign.js");
var import_sign2 = require("./jws/flattened/sign.js");
var import_sign3 = require("./jws/general/sign.js");
var import_sign4 = require("./jwt/sign.js");
var import_encrypt4 = require("./jwt/encrypt.js");
var import_thumbprint = require("./jwk/thumbprint.js");
var import_embedded = require("./jwk/embedded.js");
var import_local = require("./jwks/local.js");
var import_remote = require("./jwks/remote.js");
var import_unsecured = require("./jwt/unsecured.js");
var import_export = require("./key/export.js");
var import_import = require("./key/import.js");
var import_decode_protected_header = require("./util/decode_protected_header.js");
var import_decode_jwt = require("./util/decode_jwt.js");
var errors = __toESM(require("./util/errors.js"));
var import_generate_key_pair = require("./key/generate_key_pair.js");
var import_generate_secret = require("./key/generate_secret.js");
var base64url = __toESM(require("./util/base64url.js"));
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CompactEncrypt,
  CompactSign,
  EmbeddedJWK,
  EncryptJWT,
  FlattenedEncrypt,
  FlattenedSign,
  GeneralEncrypt,
  GeneralSign,
  SignJWT,
  UnsecuredJWT,
  base64url,
  calculateJwkThumbprint,
  calculateJwkThumbprintUri,
  compactDecrypt,
  compactVerify,
  createLocalJWKSet,
  createRemoteJWKSet,
  decodeJwt,
  decodeProtectedHeader,
  errors,
  exportJWK,
  exportPKCS8,
  exportSPKI,
  flattenedDecrypt,
  flattenedVerify,
  generalDecrypt,
  generalVerify,
  generateKeyPair,
  generateSecret,
  importJWK,
  importPKCS8,
  importSPKI,
  importX509,
  jwtDecrypt,
  jwtVerify
});
