var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var decrypt_exports = {};
__export(decrypt_exports, {
  compactDecrypt: () => compactDecrypt
});
module.exports = __toCommonJS(decrypt_exports);
var import_decrypt = require("../flattened/decrypt.js");
var import_errors = require("../../util/errors.js");
var import_buffer_utils = require("../../lib/buffer_utils.js");
async function compactDecrypt(jwe, key, options) {
  if (jwe instanceof Uint8Array) {
    jwe = import_buffer_utils.decoder.decode(jwe);
  }
  if (typeof jwe !== "string") {
    throw new import_errors.JWEInvalid("Compact JWE must be a string or Uint8Array");
  }
  const {
    0: protectedHeader,
    1: encryptedKey,
    2: iv,
    3: ciphertext,
    4: tag,
    length
  } = jwe.split(".");
  if (length !== 5) {
    throw new import_errors.JWEInvalid("Invalid Compact JWE");
  }
  const decrypted = await (0, import_decrypt.flattenedDecrypt)(
    {
      ciphertext,
      iv: iv || void 0,
      protected: protectedHeader || void 0,
      tag: tag || void 0,
      encrypted_key: encryptedKey || void 0
    },
    key,
    options
  );
  const result = { plaintext: decrypted.plaintext, protectedHeader: decrypted.protectedHeader };
  if (typeof key === "function") {
    return { ...result, key: decrypted.key };
  }
  return result;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  compactDecrypt
});
