var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var unsecured_exports = {};
__export(unsecured_exports, {
  UnsecuredJWT: () => UnsecuredJWT
});
module.exports = __toCommonJS(unsecured_exports);
var base64url = __toESM(require("../runtime/base64url.js"));
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_errors = require("../util/errors.js");
var import_jwt_claims_set = __toESM(require("../lib/jwt_claims_set.js"));
var import_produce = require("./produce.js");
class UnsecuredJWT extends import_produce.ProduceJWT {
  /** Encodes the Unsecured JWT. */
  encode() {
    const header = base64url.encode(JSON.stringify({ alg: "none" }));
    const payload = base64url.encode(JSON.stringify(this._payload));
    return `${header}.${payload}.`;
  }
  /**
   * Decodes an unsecured JWT.
   *
   * @param jwt Unsecured JWT to decode the payload of.
   * @param options JWT Claims Set validation options.
   */
  static decode(jwt, options) {
    if (typeof jwt !== "string") {
      throw new import_errors.JWTInvalid("Unsecured JWT must be a string");
    }
    const { 0: encodedHeader, 1: encodedPayload, 2: signature, length } = jwt.split(".");
    if (length !== 3 || signature !== "") {
      throw new import_errors.JWTInvalid("Invalid Unsecured JWT");
    }
    let header;
    try {
      header = JSON.parse(import_buffer_utils.decoder.decode(base64url.decode(encodedHeader)));
      if (header.alg !== "none")
        throw new Error();
    } catch {
      throw new import_errors.JWTInvalid("Invalid Unsecured JWT");
    }
    const payload = (0, import_jwt_claims_set.default)(header, base64url.decode(encodedPayload), options);
    return { payload, header };
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  UnsecuredJWT
});
