var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var check_cek_length_exports = {};
__export(check_cek_length_exports, {
  default: () => check_cek_length_default
});
module.exports = __toCommonJS(check_cek_length_exports);
var import_errors = require("../util/errors.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
const checkCekLength = (enc, cek) => {
  let expected;
  switch (enc) {
    case "A128CBC-HS256":
    case "A192CBC-HS384":
    case "A256CBC-HS512":
      expected = parseInt(enc.slice(-3), 10);
      break;
    case "A128GCM":
    case "A192GCM":
    case "A256GCM":
      expected = parseInt(enc.slice(1, 4), 10);
      break;
    default:
      throw new import_errors.JOSENotSupported(
        `Content Encryption Algorithm ${enc} is not supported either by JOSE or your javascript runtime`
      );
  }
  if (cek instanceof Uint8Array) {
    const actual = cek.byteLength << 3;
    if (actual !== expected) {
      throw new import_errors.JWEInvalid(
        `Invalid Content Encryption Key length. Expected ${expected} bits, got ${actual} bits`
      );
    }
    return;
  }
  if ((0, import_is_key_object.default)(cek) && cek.type === "secret") {
    const actual = cek.symmetricKeySize << 3;
    if (actual !== expected) {
      throw new import_errors.JWEInvalid(
        `Invalid Content Encryption Key length. Expected ${expected} bits, got ${actual} bits`
      );
    }
    return;
  }
  throw new TypeError("Invalid Content Encryption Key type");
};
var check_cek_length_default = checkCekLength;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
