var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ecdhes_exports = {};
__export(ecdhes_exports, {
  deriveKey: () => deriveKey,
  ecdhAllowed: () => ecdhAllowed,
  generateEpk: () => generateEpk
});
module.exports = __toCommonJS(ecdhes_exports);
var import_crypto = require("crypto");
var import_util = require("util");
var import_get_named_curve = __toESM(require("./get_named_curve.js"));
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_errors = require("../util/errors.js");
var import_webcrypto = require("./webcrypto.js");
var import_crypto_key = require("../lib/crypto_key.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const generateKeyPair = (0, import_util.promisify)(import_crypto.generateKeyPair);
async function deriveKey(publicKee, privateKee, algorithm, keyLength, apu = new Uint8Array(0), apv = new Uint8Array(0)) {
  let publicKey;
  if ((0, import_webcrypto.isCryptoKey)(publicKee)) {
    (0, import_crypto_key.checkEncCryptoKey)(publicKee, "ECDH");
    publicKey = import_crypto.KeyObject.from(publicKee);
  } else if ((0, import_is_key_object.default)(publicKee)) {
    publicKey = publicKee;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(publicKee, ...import_is_key_like.types));
  }
  let privateKey;
  if ((0, import_webcrypto.isCryptoKey)(privateKee)) {
    (0, import_crypto_key.checkEncCryptoKey)(privateKee, "ECDH", "deriveBits");
    privateKey = import_crypto.KeyObject.from(privateKee);
  } else if ((0, import_is_key_object.default)(privateKee)) {
    privateKey = privateKee;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(privateKee, ...import_is_key_like.types));
  }
  const value = (0, import_buffer_utils.concat)(
    (0, import_buffer_utils.lengthAndInput)(import_buffer_utils.encoder.encode(algorithm)),
    (0, import_buffer_utils.lengthAndInput)(apu),
    (0, import_buffer_utils.lengthAndInput)(apv),
    (0, import_buffer_utils.uint32be)(keyLength)
  );
  const sharedSecret = (0, import_crypto.diffieHellman)({ privateKey, publicKey });
  return (0, import_buffer_utils.concatKdf)(sharedSecret, keyLength, value);
}
async function generateEpk(kee) {
  let key;
  if ((0, import_webcrypto.isCryptoKey)(kee)) {
    key = import_crypto.KeyObject.from(kee);
  } else if ((0, import_is_key_object.default)(kee)) {
    key = kee;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(kee, ...import_is_key_like.types));
  }
  switch (key.asymmetricKeyType) {
    case "x25519":
      return generateKeyPair("x25519");
    case "x448": {
      return generateKeyPair("x448");
    }
    case "ec": {
      const namedCurve = (0, import_get_named_curve.default)(key);
      return generateKeyPair("ec", { namedCurve });
    }
    default:
      throw new import_errors.JOSENotSupported("Invalid or unsupported EPK");
  }
}
const ecdhAllowed = (key) => ["P-256", "P-384", "P-521", "X25519", "X448"].includes((0, import_get_named_curve.default)(key));
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  deriveKey,
  ecdhAllowed,
  generateEpk
});
