var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var get_named_curve_exports = {};
__export(get_named_curve_exports, {
  default: () => get_named_curve_default,
  setCurve: () => setCurve,
  weakMap: () => weakMap
});
module.exports = __toCommonJS(get_named_curve_exports);
var import_buffer = require("buffer");
var import_crypto = require("crypto");
var import_errors = require("../util/errors.js");
var import_webcrypto = require("./webcrypto.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const p256 = import_buffer.Buffer.from([42, 134, 72, 206, 61, 3, 1, 7]);
const p384 = import_buffer.Buffer.from([43, 129, 4, 0, 34]);
const p521 = import_buffer.Buffer.from([43, 129, 4, 0, 35]);
const secp256k1 = import_buffer.Buffer.from([43, 129, 4, 0, 10]);
const weakMap = /* @__PURE__ */ new WeakMap();
const namedCurveToJOSE = (namedCurve) => {
  switch (namedCurve) {
    case "prime256v1":
      return "P-256";
    case "secp384r1":
      return "P-384";
    case "secp521r1":
      return "P-521";
    case "secp256k1":
      return "secp256k1";
    default:
      throw new import_errors.JOSENotSupported("Unsupported key curve for this operation");
  }
};
const getNamedCurve = (kee, raw) => {
  var _a;
  let key;
  if ((0, import_webcrypto.isCryptoKey)(kee)) {
    key = import_crypto.KeyObject.from(kee);
  } else if ((0, import_is_key_object.default)(kee)) {
    key = kee;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(kee, ...import_is_key_like.types));
  }
  if (key.type === "secret") {
    throw new TypeError('only "private" or "public" type keys can be used for this operation');
  }
  switch (key.asymmetricKeyType) {
    case "ed25519":
    case "ed448":
      return `Ed${key.asymmetricKeyType.slice(2)}`;
    case "x25519":
    case "x448":
      return `X${key.asymmetricKeyType.slice(1)}`;
    case "ec": {
      if (weakMap.has(key)) {
        return weakMap.get(key);
      }
      let namedCurve = (_a = key.asymmetricKeyDetails) == null ? void 0 : _a.namedCurve;
      if (!namedCurve && key.type === "private") {
        namedCurve = getNamedCurve((0, import_crypto.createPublicKey)(key), true);
      } else if (!namedCurve) {
        const buf = key.export({ format: "der", type: "spki" });
        const i = buf[1] < 128 ? 14 : 15;
        const len = buf[i];
        const curveOid = buf.slice(i + 1, i + 1 + len);
        if (curveOid.equals(p256)) {
          namedCurve = "prime256v1";
        } else if (curveOid.equals(p384)) {
          namedCurve = "secp384r1";
        } else if (curveOid.equals(p521)) {
          namedCurve = "secp521r1";
        } else if (curveOid.equals(secp256k1)) {
          namedCurve = "secp256k1";
        } else {
          throw new import_errors.JOSENotSupported("Unsupported key curve for this operation");
        }
      }
      if (raw)
        return namedCurve;
      const curve = namedCurveToJOSE(namedCurve);
      weakMap.set(key, curve);
      return curve;
    }
    default:
      throw new TypeError("Invalid asymmetric key type for this operation");
  }
};
function setCurve(keyObject, curve) {
  weakMap.set(keyObject, curve);
}
var get_named_curve_default = getNamedCurve;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  setCurve,
  weakMap
});
