var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var rsaes_exports = {};
__export(rsaes_exports, {
  decrypt: () => decrypt,
  encrypt: () => encrypt
});
module.exports = __toCommonJS(rsaes_exports);
var import_crypto = require("crypto");
var import_check_modulus_length = __toESM(require("./check_modulus_length.js"));
var import_webcrypto = require("./webcrypto.js");
var import_crypto_key = require("../lib/crypto_key.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const checkKey = (key, alg) => {
  if (key.asymmetricKeyType !== "rsa") {
    throw new TypeError("Invalid key for this operation, its asymmetricKeyType must be rsa");
  }
  (0, import_check_modulus_length.default)(key, alg);
};
const resolvePadding = (alg) => {
  switch (alg) {
    case "RSA-OAEP":
    case "RSA-OAEP-256":
    case "RSA-OAEP-384":
    case "RSA-OAEP-512":
      return import_crypto.constants.RSA_PKCS1_OAEP_PADDING;
    case "RSA1_5":
      return import_crypto.constants.RSA_PKCS1_PADDING;
    default:
      return void 0;
  }
};
const resolveOaepHash = (alg) => {
  switch (alg) {
    case "RSA-OAEP":
      return "sha1";
    case "RSA-OAEP-256":
      return "sha256";
    case "RSA-OAEP-384":
      return "sha384";
    case "RSA-OAEP-512":
      return "sha512";
    default:
      return void 0;
  }
};
function ensureKeyObject(key, alg, ...usages) {
  if ((0, import_is_key_object.default)(key)) {
    return key;
  }
  if ((0, import_webcrypto.isCryptoKey)(key)) {
    (0, import_crypto_key.checkEncCryptoKey)(key, alg, ...usages);
    return import_crypto.KeyObject.from(key);
  }
  throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
}
const encrypt = (alg, key, cek) => {
  const padding = resolvePadding(alg);
  const oaepHash = resolveOaepHash(alg);
  const keyObject = ensureKeyObject(key, alg, "wrapKey", "encrypt");
  checkKey(keyObject, alg);
  return (0, import_crypto.publicEncrypt)({ key: keyObject, oaepHash, padding }, cek);
};
const decrypt = (alg, key, encryptedKey) => {
  const padding = resolvePadding(alg);
  const oaepHash = resolveOaepHash(alg);
  const keyObject = ensureKeyObject(key, alg, "unwrapKey", "decrypt");
  checkKey(keyObject, alg);
  return (0, import_crypto.privateDecrypt)({ key: keyObject, oaepHash, padding }, encryptedKey);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decrypt,
  encrypt
});
