var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var sign_exports = {};
__export(sign_exports, {
  default: () => sign_default
});
module.exports = __toCommonJS(sign_exports);
var crypto = __toESM(require("crypto"));
var import_util = require("util");
var import_dsa_digest = __toESM(require("./dsa_digest.js"));
var import_hmac_digest = __toESM(require("./hmac_digest.js"));
var import_node_key = __toESM(require("./node_key.js"));
var import_get_sign_verify_key = __toESM(require("./get_sign_verify_key.js"));
let oneShotSign;
if (crypto.sign.length > 3) {
  oneShotSign = (0, import_util.promisify)(crypto.sign);
} else {
  oneShotSign = crypto.sign;
}
const sign = async (alg, key, data) => {
  const keyObject = (0, import_get_sign_verify_key.default)(alg, key, "sign");
  if (alg.startsWith("HS")) {
    const hmac = crypto.createHmac((0, import_hmac_digest.default)(alg), keyObject);
    hmac.update(data);
    return hmac.digest();
  }
  return oneShotSign((0, import_dsa_digest.default)(alg), data, (0, import_node_key.default)(alg, keyObject));
};
var sign_default = sign;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
