var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var check_key_type_exports = {};
__export(check_key_type_exports, {
  default: () => check_key_type_default
});
module.exports = __toCommonJS(check_key_type_exports);
var import_invalid_key_input = require("./invalid_key_input.js");
var import_is_key_like = __toESM(require("../runtime/is_key_like.js"));
const symmetricTypeCheck = (alg, key) => {
  if (key instanceof Uint8Array)
    return;
  if (!(0, import_is_key_like.default)(key)) {
    throw new TypeError((0, import_invalid_key_input.withAlg)(alg, key, ...import_is_key_like.types, "Uint8Array"));
  }
  if (key.type !== "secret") {
    throw new TypeError(
      `${import_is_key_like.types.join(" or ")} instances for symmetric algorithms must be of type "secret"`
    );
  }
};
const asymmetricTypeCheck = (alg, key, usage) => {
  if (!(0, import_is_key_like.default)(key)) {
    throw new TypeError((0, import_invalid_key_input.withAlg)(alg, key, ...import_is_key_like.types));
  }
  if (key.type === "secret") {
    throw new TypeError(
      `${import_is_key_like.types.join(" or ")} instances for asymmetric algorithms must not be of type "secret"`
    );
  }
  if (usage === "sign" && key.type === "public") {
    throw new TypeError(
      `${import_is_key_like.types.join(" or ")} instances for asymmetric algorithm signing must be of type "private"`
    );
  }
  if (usage === "decrypt" && key.type === "public") {
    throw new TypeError(
      `${import_is_key_like.types.join(
        " or "
      )} instances for asymmetric algorithm decryption must be of type "private"`
    );
  }
  if (key.algorithm && usage === "verify" && key.type === "private") {
    throw new TypeError(
      `${import_is_key_like.types.join(" or ")} instances for asymmetric algorithm verifying must be of type "public"`
    );
  }
  if (key.algorithm && usage === "encrypt" && key.type === "private") {
    throw new TypeError(
      `${import_is_key_like.types.join(
        " or "
      )} instances for asymmetric algorithm encryption must be of type "public"`
    );
  }
};
const checkKeyType = (alg, key, usage) => {
  const symmetric = alg.startsWith("HS") || alg === "dir" || alg.startsWith("PBES2") || /^A\d{3}(?:GCM)?KW$/.test(alg);
  if (symmetric) {
    symmetricTypeCheck(alg, key);
  } else {
    asymmetricTypeCheck(alg, key, usage);
  }
};
var check_key_type_default = checkKeyType;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
