var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var fetch_jwks_exports = {};
__export(fetch_jwks_exports, {
  default: () => fetch_jwks_default
});
module.exports = __toCommonJS(fetch_jwks_exports);
var http = __toESM(require("http"));
var https = __toESM(require("https"));
var import_events = require("events");
var import_errors = require("../util/errors.js");
var import_buffer_utils = require("../lib/buffer_utils.js");
const fetchJwks = async (url, timeout, options) => {
  let get;
  switch (url.protocol) {
    case "https:":
      get = https.get;
      break;
    case "http:":
      get = http.get;
      break;
    default:
      throw new TypeError("Unsupported URL protocol.");
  }
  const { agent, headers } = options;
  const req = get(url.href, {
    agent,
    timeout,
    headers
  });
  const [response] = await Promise.race([(0, import_events.once)(req, "response"), (0, import_events.once)(req, "timeout")]);
  if (!response) {
    req.destroy();
    throw new import_errors.JWKSTimeout();
  }
  if (response.statusCode !== 200) {
    throw new import_errors.JOSEError("Expected 200 OK from the JSON Web Key Set HTTP response");
  }
  const parts = [];
  for await (const part of response) {
    parts.push(part);
  }
  try {
    return JSON.parse(import_buffer_utils.decoder.decode((0, import_buffer_utils.concat)(...parts)));
  } catch {
    throw new import_errors.JOSEError("Failed to parse the JSON Web Key Set HTTP response as JSON");
  }
};
var fetch_jwks_default = fetchJwks;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
